#ifdef WUNDERGR_FEATURE
//################# LIBRARIES ################
String version = "AMS ESP8266";       // Version of this program

#include <ESP8266WiFi.h>
//#include <ESP8266WebServer.h>
#include <WiFiClient.h>
#include <ArduinoJson.h>
#include <DNSServer.h>
//################ VARIABLES ################

//------ NETWORK VARIABLES---------
// Use your own API key by signing up for a free developer account at http://www.wunderground.com/weather/api/
//int    port          = 5000;

int    port_2         = 5000;
String API_key       = "****************";            // See: http://www.wunderground.com/weather/api/d/docs (change here with your KEY)
String City          = "Chisinau";                     // Your home city
String Country       = "MD";                          // Your country   
String Conditions    = "conditions";                  // See: http://www.wunderground.com/weather/api/d/docs?d=data/index&MR=1
char   wxserver[]    = "api.wunderground.com";        // Address for WeatherUnderGround
unsigned long        lastConnectionTime = 0;          // Last time you connected to the server, in milliseconds
const unsigned long  postingInterval = 30L*60L*1000L; // Delay between updates, in milliseconds, WU allows 500 requests per-day maximum, set to every 30-mins or 48/day
String SITE_WIDTH =  "900";
String icon_set   =  "k";
String Units      =  "X"; // Default use either M for Metric, X for Mixed and I for Imperial

//const char *ssid     = "*****";
//const char *password = "*****";
// EthernetClient object
WiFiClient uclient;

//################ PROGRAM VARIABLES and OBJECTS ################
// Conditions
String webpage, city, country, date_time, observationtime,
       DWDay0, DMon0, DDateDa0, DDateMo0, DDateYr0, Dicon_url0, DHtemp0, DLtemp0, DHumi0, Dpop0, DRain0, DW_mph0, DW_dir0, DW_dir_deg0, 
       DWDay1, DMon1, DDateDa1, DDateMo1, DDateYr1, Dicon_url1, DHtemp1, DLtemp1, DHumi1, DPop1, DRain1, DW_mph1, DW_dir1, DW_dir_deg1, 
       DWDay2, DMon2, DDateDa2, DDateMo2, DDateYr2, Dicon_url2, DHtemp2, DLtemp2, DHumi2, DPop2, DRain2, DW_mph2, DW_dir2, DW_dir_deg2, 
       DWDay3, DMon3, DDateDa3, DDateMo3, DDateYr3, Dicon_url3, DHtemp3, DLtemp3, DHumi3, DPop3, DRain3, DW_mph3, DW_dir3, DW_dir_deg3,
       DWDay4, DMon4, DDateDa4, DDateMo4, DDateYr4, Dicon_url4, DHtemp4, DLtemp4, DHumi4, DPop4, DRain4, DW_mph4, DW_dir4, DW_dir_deg4;

// Astronomy
String  DphaseofMoon, Sunrise, Sunset, moon_url;
       
//ESP8266WebServer server(port_2); // Start server on port 80 (default for a web-browser, change to your requirements, e.g. 8080 if your Router uses port 80
                               // To access server from the outside of a WiFi network e.g. ESP8266WebServer server(8266) add a rule on your Router that forwards a
                               // connection request to http://your_network_ip_address:8266 to port 8266 and view your ESP server from anywhere.
                               // Example http://yourhome.ip:8266 will be directed to http://192.168.0.40:8266 or whatever IP address your router gives to this server

void twundergrInit() {
  initStart("WD");
  //timeStamp();

  
//  server.begin(); Serial.println(F("Webserver started...")); // Start the webserver
  Serial.print(F("Use this URL to connect: http://")); Serial.println(WiFi.localIP().toString()+"/");// Print the IP address
 // server.on("/", SystemSetup);//=====================================
 // server.on("/homepage", homepage);//===================================
  lastConnectionTime = millis();
  delay(10);
  obtain_forecast("forecast");

    delay(200);
  uclient.stop();
  modulTwundergr = MODUL_ENABLE;
  initDone();
}

void twundergrWorks() {

//    server.handleClient();
  if (millis() - lastConnectionTime > postingInterval) {
    obtain_forecast("forecast");
    lastConnectionTime = millis();
  }
//Serial.println(DHtemp1);
}

void homepage(){
  append_page_header(); 
  webpage += F("<hr>");
  webpage += F("<table class='style7'>");
  webpage += F("      <tr>");
  webpage += "          <th>"+DWDay1+"</th>";
  webpage += "          <th>"+DWDay2+"</th>";
  webpage += "          <th>"+DWDay3+"</th>";
  webpage += "          <th>"+DWDay4+"</th>";
  webpage += F("      </tr>");
  webpage += F("      <tr>");
  webpage += F("        <td>");
  webpage += "            "+DDateDa1+"-"+DMon1+"-"+DDateYr1;
  webpage += F("        </td>");
  webpage += F("        <td>");
  webpage += "            "+DDateDa2+"-"+DMon2+"-"+DDateYr2;
  webpage += F("        </td>");
  webpage += F("        <td>");
  webpage += "            "+DDateDa3+"-"+DMon2+"-"+DDateYr3;
  webpage += F("        </td>");
  webpage += F("        <td>");
  webpage += "            "+DDateDa4+"-"+DMon3+"-"+DDateYr4;
  webpage += F("        </td>");
  webpage += F("      </tr>");
  webpage += F("      <tr>");
  webpage += "          <td> <img class='imgdisplay' alt='wx' height='70' src='"+Dicon_url1+"' width='70'/></td>";
  webpage += "          <td> <img class='imgdisplay' alt='wx' height='70' src='"+Dicon_url2+"' width='70'/></td>";
  webpage += "          <td> <img class='imgdisplay' alt='wx' height='70' src='"+Dicon_url3+"' width='70'/></td>";
  webpage += "          <td> <img class='imgdisplay' alt='wx' height='70' src='"+Dicon_url4+"' width='70'/></td>";
  webpage += F("      </tr>");
  webpage += F("      <tr>");  
  webpage += F("        <td class='style8'>Max - Min - Hum</td>");
  webpage += F("        <td class='style8'>Max - Min - Hum</td>");
  webpage += F("        <td class='style8'>Max - Min - Hum</td>");
  webpage += F("        <td class='style8'>Max - Min - Hum</td>");
  webpage += F("      </tr>");
  webpage += F("      <tr>");
  webpage += F("        <td class='style9'>");
  webpage += "            &nbsp"+DHtemp1+"&deg;&nbsp;&nbsp;&nbsp;&nbsp"+DLtemp1+"&deg;&nbsp;&nbsp;&nbsp;&nbsp"+DHumi1+"%</td>";
  webpage += F("        </td>");
  webpage += F("        <td class='style9'>");
  webpage += "            &nbsp"+DHtemp2+"&deg;&nbsp;&nbsp;&nbsp;&nbsp"+DLtemp2+"&deg;&nbsp;&nbsp;&nbsp;&nbsp"+DHumi2+"%</td>";
  webpage += F("        </td>");
  webpage += F("        <td class='style9'>");
  webpage += "            &nbsp"+DHtemp3+"&deg;&nbsp;&nbsp;&nbsp;&nbsp"+DLtemp3+"&deg;&nbsp;&nbsp;&nbsp;&nbsp"+DHumi3+"%</td>";
  webpage += F("        </td>");
  webpage += F("        <td class='style9'>");
  webpage += "            &nbsp"+DHtemp4+"&deg;&nbsp;&nbsp;&nbsp;&nbsp"+DLtemp4+"&deg;&nbsp;&nbsp;&nbsp;&nbsp"+DHumi4+"%</td>";
  webpage += F("        </td>");
  webpage += F("      </tr>");
  webpage += F("      <tr>");
  webpage += F("        <td class='style9'>");
  webpage += "            "+winddirsymbol(&DW_dir1) + " @ " + DW_mph1;
  webpage += F("        </td>");
  webpage += F("        <td class='style9'>");
  webpage += "            "+winddirsymbol(&DW_dir2) + " @ " + DW_mph2;
  webpage += F("        </td>");
  webpage += F("        <td class='style9'>");
  webpage += "            "+winddirsymbol(&DW_dir3) + " @ " + DW_mph3;
  webpage += F("        </td>");
  webpage += F("        <td class='style9'>");
  webpage += "            "+winddirsymbol(&DW_dir4) + " @ " + DW_mph4;
  webpage += F("        </td>");
  webpage += F("      </tr>");
  webpage += F("      <tr>");
  webpage += F("        <td class='style8'>");
  webpage += "            "+DPop1+"% chance of "+((DRain1=="0mm"||DRain1=="0in")?"rain":DRain1+" rain");
  webpage += F("        </td>");
  webpage += F("        <td class='style8'>");
  webpage += "            "+DPop2+"% chance of "+((DRain2=="0mm"||DRain2=="0in")?"rain":DRain2+" rain");
  webpage += F("        </td>");
  webpage += F("        <td class='style8'>");
  webpage += "            "+DPop3+"% chance of "+((DRain3=="0mm"||DRain3=="0in")?"rain":DRain3+" rain");
  webpage += F("        </td>");
  webpage += F("        <td class='style8'>");
  webpage += "            "+DPop4+"% chance of "+((DRain4=="0mm"||DRain4=="0in")?"rain":DRain4+" rain");
  webpage += F("        </td>");
  webpage += F("      </tr>");
  webpage += F("    </table>");
  webpage += F("<br>");
  append_page_footer();
//  server.send(200, "text/html", webpage);
}

void obtain_forecast (String forecast_type) {
  static char RxBuf[8704];
  String request;
  request  = "GET /api/" + API_key + "/"+ forecast_type + "/q/" + Country + "/" + City + ".json HTTP/1.1\r\n";
  request += F("User-Agent: Weather Webserver v");
  request += version;
  request += F("\r\n");
  request += F("Accept: */*\r\n");
  request += "Host: " + String(wxserver) + "\r\n";
  request += F("Connection: close\r\n");
  request += F("\r\n");
  Serial.println(request);
  Serial.print(F("Connecting to ")); Serial.println(wxserver);
  WiFiClient httpclient;
  if (!httpclient.connect(wxserver, 80)) {
    Serial.println(F("connection failed"));
    httpclient.flush();
    httpclient.stop();
    return;
  }
  Serial.print(request);
  httpclient.print(request); //send the http request to the server
  httpclient.flush();
  // Collect http response headers and content from Weather Underground, discarding HTTP headers, the content is JSON formatted and will be returned in RxBuf.
  int    respLen = 0;
  bool   skip_headers = true;
  String rx_line;
  while (httpclient.connected() || httpclient.available()) {
    if (skip_headers) {
      rx_line = httpclient.readStringUntil('\n'); //Serial.println(rx_line);
      if (rx_line.length() <= 1) { // a blank line denotes end of headers
        skip_headers = false;
      }
    }
    else {
      int bytesIn;
      bytesIn = httpclient.read((uint8_t *)&RxBuf[respLen], sizeof(RxBuf) - respLen);
      //Serial.print(F("bytesIn ")); Serial.println(bytesIn);
      if (bytesIn > 0) {
        respLen += bytesIn;
        if (respLen > sizeof(RxBuf)) respLen = sizeof(RxBuf);
      }
      else if (bytesIn < 0) {
        Serial.print(F("read error "));
        Serial.println(bytesIn);
      }
    }
    delay(1);
  }
  httpclient.stop();

  if (respLen >= sizeof(RxBuf)) {
    Serial.print(F("RxBuf overflow "));
    Serial.println(respLen);
    delay(1000);
    return;
  }
  RxBuf[respLen++] = '\0'; // Terminate the C string
  Serial.print(F("respLen ")); Serial.println(respLen); //Serial.println(RxBuf);
  if (forecast_type == "forecast"){
    if (showWeather_forecast(RxBuf))   delay(1000); 
  }
}

bool showWeather_forecast(char *json) {
  DynamicJsonBuffer jsonBuffer(8704);
  char *jsonstart = strchr(json, '{');
  //Serial.print(F("jsonstart ")); Serial.println(jsonstart);
  if (jsonstart == NULL) {
    Serial.println(F("JSON data missing"));
    return false;
  }
  json = jsonstart;

  // Parse JSON
  JsonObject& root = jsonBuffer.parseObject(json);
  if (!root.success()) {
    Serial.println(F("jsonBuffer.parseObject() failed"));
    return false;
  }

  JsonObject& forecast = root["forecast"]["simpleforecast"];
  String WDay1      = forecast["forecastday"][0]["date"]["weekday_short"];   DWDay1      = WDay1;
  int DateDa1       = forecast["forecastday"][0]["date"]["day"];             DDateDa1    = DateDa1<10?"0"+String(DateDa1):String(DateDa1);
  String Temp_mon   = forecast["forecastday"][0]["date"]["monthname"];
  String Mon1       = forecast["forecastday"][0]["date"]["monthname_short"]; DMon1       = Mon1;
  int DateYr1       = forecast["forecastday"][0]["date"]["year"];            DDateYr1    = String(DateYr1).substring(2);
  observationtime   = "from " + String(DDateDa1) + " " + Temp_mon + ", " + DateYr1;
  if (Units == "M" || Units == "X") {
    int Htemp1        = forecast["forecastday"][0]["high"]["celsius"];       DHtemp1     = String(Htemp1);
    int Ltemp1        = forecast["forecastday"][0]["low"]["celsius"];        DLtemp1     = String(Ltemp1);
    int rain1         = forecast["forecastday"][0]["qpf_allday"]["mm"];      DRain1      = String(rain1)+"mm";
    if (Units == "M") {int w_mph1 = forecast["forecastday"][0]["avewind"]["kph"];  DW_mph1 = String(w_mph1)+"kph";}
    else {int w_mph1   = forecast["forecastday"][0]["avewind"]["mph"];  DW_mph1 = String(w_mph1)+"mph";}
  }
  else
  {
    int Htemp1        = forecast["forecastday"][0]["high"]["fahrenheit"];    DHtemp1     = String(Htemp1);
    int Ltemp1        = forecast["forecastday"][0]["low"]["fahrenheit"];     DLtemp1     = String(Ltemp1);
    int rain1         = forecast["forecastday"][0]["qpf_allday"]["in"];      DRain1      = String(rain1)+"in";
    int w_mph1        = forecast["forecastday"][0]["avewind"]["mph"];        DW_mph1     = String(w_mph1)+"mph";
  }
  String icon_url1  = forecast["forecastday"][0]["icon_url"];           
  Dicon_url1        = icon_url1.substring(0,icon_url1.indexOf("/i/c/")+5) + icon_set + icon_url1.substring(icon_url1.indexOf("/i/c/")+6);
  String pop1       = forecast["forecastday"][0]["pop"];                     DPop1       = String(pop1);
  String w_dir1     = forecast["forecastday"][0]["avewind"]["dir"];          DW_dir1     = String(w_dir1);
  String w_dir_deg1 = forecast["forecastday"][0]["avewind"]["degrees"];      DW_dir_deg1 = String(w_dir_deg1);
  int humi1         = forecast["forecastday"][0]["avehumidity"];             DHumi1      = String(humi1);

  String WDay2      = forecast["forecastday"][1]["date"]["weekday_short"];   DWDay2      = WDay2;
  int DateDa2       = forecast["forecastday"][1]["date"]["day"];             DDateDa2    = DateDa2<10?"0"+String(DateDa2):String(DateDa2);
  String Mon2       = forecast["forecastday"][1]["date"]["monthname_short"]; DMon2       = Mon2;
  int DateYr2       = forecast["forecastday"][1]["date"]["year"];            DDateYr2    = String(DateYr2).substring(2);
  if (Units == "M" || Units == "X") {
    int Htemp2        = forecast["forecastday"][1]["high"]["celsius"];       DHtemp2     = String(Htemp2);
    int Ltemp2        = forecast["forecastday"][1]["low"]["celsius"];        DLtemp2     = String(Ltemp2);
    int rain2         = forecast["forecastday"][1]["qpf_allday"]["mm"];      DRain2      = String(rain2)+"mm";
    if (Units == "M"){int w_mph2 = forecast["forecastday"][1]["avewind"]["kph"]; DW_mph2 = String(w_mph2)+"kph";}
    else {int w_mph2  = forecast["forecastday"][1]["avewind"]["mph"];        DW_mph2     = String(w_mph2)+"mph";
    }
  }
  else
  {
    int Htemp2        = forecast["forecastday"][1]["high"]["fahrenheit"];    DHtemp2     = String(Htemp2);
    int Ltemp2        = forecast["forecastday"][1]["low"]["fahrenheit"];     DLtemp2     = String(Ltemp2);
    int rain2         = forecast["forecastday"][1]["qpf_allday"]["in"];      DRain2      = String(rain2)+"in";
    int w_mph2        = forecast["forecastday"][1]["avewind"]["mph"];        DW_mph2     = String(w_mph2)+"mph";
  }
  String icon_url2  = forecast["forecastday"][1]["icon_url"];           
  Dicon_url2        = icon_url2.substring(0,icon_url2.indexOf("/i/c/")+5) + icon_set + icon_url2.substring(icon_url2.indexOf("/i/c/")+6);
  String pop2       = forecast["forecastday"][1]["pop"];                     DPop2       = String(pop2);
  String w_dir2     = forecast["forecastday"][1]["avewind"]["dir"];          DW_dir2     = String(w_dir2);
  String w_dir_deg2 = forecast["forecastday"][1]["avewind"]["degrees"];      DW_dir_deg2 = String(w_dir_deg2);
  int humi2         = forecast["forecastday"][1]["avehumidity"];             DHumi2      = String(humi2);

  String WDay3      = forecast["forecastday"][2]["date"]["weekday_short"];   DWDay3      = WDay3;
  int DateDa3       = forecast["forecastday"][2]["date"]["day"];             DDateDa3    = DateDa3<10?"0"+String(DateDa3):String(DateDa3);
  String Mon3       = forecast["forecastday"][2]["date"]["monthname_short"]; DMon3       = Mon3;
  int DateYr3       = forecast["forecastday"][2]["date"]["year"];            DDateYr3    = String(DateYr3).substring(2);
  if (Units == "M" || Units == "X") {
    int Htemp3        = forecast["forecastday"][2]["high"]["celsius"];       DHtemp3     = String(Htemp3);
    int Ltemp3        = forecast["forecastday"][2]["low"]["celsius"];        DLtemp3     = String(Ltemp3);
    int rain3         = forecast["forecastday"][2]["qpf_allday"]["mm"];      DRain3      = String(rain3)+"mm";
    if (Units == "M") {int w_mph3 = forecast["forecastday"][2]["avewind"]["kph"]; DW_mph3 = String(w_mph3)+"kph"; }
    else {int w_mph3  = forecast["forecastday"][2]["avewind"]["mph"];        DW_mph3     = String(w_mph3)+"mph"; }
  }
  else
  {
    int Htemp3        = forecast["forecastday"][2]["high"]["fahrenheit"];    DHtemp3     = String(Htemp3);
    int Ltemp3        = forecast["forecastday"][2]["low"]["fahrenheit"];     DLtemp3     = String(Ltemp3);
    int rain3         = forecast["forecastday"][2]["qpf_allday"]["in"];      DRain3      = String(rain3)+"in";
    int w_mph3        = forecast["forecastday"][2]["avewind"]["mph"];        DW_mph3     = String(w_mph3)+"mph";
  }
  String icon_url3  = forecast["forecastday"][2]["icon_url"];           
  Dicon_url3        = icon_url3.substring(0,icon_url3.indexOf("/i/c/")+5) + icon_set + icon_url3.substring(icon_url3.indexOf("/i/c/")+6);
  String pop3       = forecast["forecastday"][2]["pop"];                     DPop3       = String(pop3);
  String w_dir3     = forecast["forecastday"][2]["avewind"]["dir"];          DW_dir3     = String(w_dir3);
  String w_dir_deg3 = forecast["forecastday"][2]["avewind"]["degrees"];      DW_dir_deg3 = String(w_dir_deg3);
  int humi3         = forecast["forecastday"][2]["avehumidity"];             DHumi3      = String(humi3);

  String WDay4      = forecast["forecastday"][3]["date"]["weekday_short"];   DWDay4      = WDay4;
  int DateDa4       = forecast["forecastday"][3]["date"]["day"];             DDateDa4    = DateDa4<10?"0"+String(DateDa4):String(DateDa4);
  String Mon4       = forecast["forecastday"][3]["date"]["monthname_short"]; DMon4       = Mon4;
  int DateYr4       = forecast["forecastday"][3]["date"]["year"];            DDateYr4    = String(DateYr4).substring(2);
  if (Units == "M" || Units == "X") {
    int Htemp4        = forecast["forecastday"][3]["high"]["celsius"];       DHtemp4     = String(Htemp4);
    int Ltemp4        = forecast["forecastday"][3]["low"]["celsius"];        DLtemp4     = String(Ltemp4);
    int rain4         = forecast["forecastday"][3]["qpf_allday"]["mm"];      DRain4      = String(rain4)+"mm";
    if (Units == "M") {int w_mph4 = forecast["forecastday"][3]["avewind"]["kph"]; DW_mph4 = String(w_mph4)+"kph";}
    else {int w_mph4  = forecast["forecastday"][3]["avewind"]["mph"];        DW_mph4     = String(w_mph4)+"mph";}
  }
  else
  {
    int Htemp4        = forecast["forecastday"][3]["high"]["fahrenheit"];    DHtemp4     = String(Htemp4);
    int Ltemp4        = forecast["forecastday"][3]["low"]["fahrenheit"];     DLtemp4     = String(Ltemp4);
    int rain4         = forecast["forecastday"][3]["qpf_allday"]["in"];      DRain4      = String(rain4)+"in";
    int w_mph4        = forecast["forecastday"][3]["avewind"]["mph"];        DW_mph4     = String(w_mph4)+"mph";
  }
  
  String icon_url4  = forecast["forecastday"][3]["icon_url"];           
  Dicon_url4        = icon_url4.substring(0,icon_url4.indexOf("/i/c/")+5) + icon_set + icon_url4.substring(icon_url4.indexOf("/i/c/")+6);
  String pop4       = forecast["forecastday"][3]["pop"];                     DPop4       = String(pop4);
  String w_dir4     = forecast["forecastday"][3]["avewind"]["dir"];          DW_dir4     = String(w_dir4);
  String w_dir_deg4 = forecast["forecastday"][3]["avewind"]["degrees"];      DW_dir_deg4 = String(w_dir_deg4);
  int humi4         = forecast["forecastday"][3]["avehumidity"];             DHumi4      = String(humi4);

//  JsonObject& current = root["forecast"]["simpleforecast"];
//  int DateDa = current["forecastday"][0]["date"]["day"];      Serial.print(String(DateDa)+"/");
//  int DateMo = current["forecastday"][0]["date"]["month"];    Serial.print((DateMo<10?"0":"")+String(DateMo)+"/");
//  int DateYr = current["forecastday"][0]["date"]["year"];     Serial.print(String(DateYr)+" ");
//  int Htemp  = current["forecastday"][0]["high"]["celsius"];  Serial.print("High temp :"+String(Htemp));
//  int Ltemp  = current["forecastday"][0]["low"]["celsius"];   Serial.println(" Low temp :"+String(Ltemp));
  return true;
}

String winddirsymbol(String *wdir){
  if (*wdir == "N" || *wdir == "North") *wdir = "&darr; N ";
  if (*wdir == "NNE")                   *wdir = "&swarr; NNE ";
  if (*wdir == "NE")                    *wdir = "&swarr; NE ";
  if (*wdir == "ENE")                   *wdir = "&swarr; ENE ";

  if (*wdir == "E" || *wdir == "East")  *wdir = "&larr; E ";
  if (*wdir == "ESE")                   *wdir = "&swarr; ESE ";
  if (*wdir == "SE")                    *wdir = "&swarr; SE ";
  if (*wdir == "SSE")                   *wdir = "&swarr; SSE ";

  if (*wdir == "S" || *wdir == "South") *wdir = "&uarr; S ";
  if (*wdir == "SSW")                   *wdir = "&nearr; SSW ";
  if (*wdir == "SW")                    *wdir = "&nearr; SW ";
  if (*wdir == "WSW")                   *wdir = "&nearr; WSW ";

  if (*wdir == "W" || *wdir == "West")  *wdir = "&rarr; W ";
  if (*wdir == "WNW")                   *wdir = "&searr; WNW ";
  if (*wdir == "NW")                    *wdir = "&searr; NW ";
  if (*wdir == "NNW")                   *wdir = "&searr; NNW ";
  return *wdir;
}

void append_page_header() {
  webpage  = F("<!DOCTYPE html><html lang='en'><head>"); // Change lauguage (en) as required
  webpage += F("<meta http-equiv='refresh' content='60'/>"); // 60-sec refresh time
  webpage += F("<meta http-equiv='content-type' content='text/html; charset=UTF-8'/>");
  webpage += F("<title>Weather Forecast</title><style>");
  webpage += F("body {width:");
  webpage += SITE_WIDTH;
  webpage += F("px;margin:0 auto;font-family:verdana, sans-serif;font-size:14px;text-align:center;color:#cc66ff;background-color:#F7F2Fd;}");
  webpage += F("ul{list-style-type:none;margin:0;padding:0;overflow:hidden;background-color:#D8BFD8;font-size:12px;}");
  webpage += F("li{float:left;border-right:1px solid #bbb;}.last-child {border-right:none;}");
  webpage += F("li a{display: block;padding:2px 10px;text-decoration:none;}");
  webpage += F("li a:hover{background-color:#FFFFFF;}");
  webpage += F("section {font-size:14px;}");
  webpage += F("p {background-color:#E3D1E2;}");
  webpage += F("div.header,div.footer{padding:0.5em;font-size:10px;color:white;background-color:gray;clear:left;}");
  webpage += F("h1{background-color:#D8BFD8;font-size:16px;}");
  webpage += F("h2{color:#9370DB;font-size:14px;}");
  webpage += F("h3{color:#9370DB;font-size:12px;}");
  webpage += F("table{font-family:arial,sans-serif;font-size:14px;border-collapse:collapse;width:100%;height:100%}");
  webpage += F("td {border:0px solid black;text-align:center;padding:2px;}");
  webpage += F("th {border:0px solid black;text-align:center;padding:2px;font-size:20px;}");
  webpage += F(".style1 {text-align:center;font-size:54px;background-color:#D8BFD8;}");
  webpage += F(".style2 {text-align:center;font-size:14px;background-color:#ADD8E6;color:#0066ff;}");
  webpage += F(".style3 {text-align:center;font-size:60px;background-color:#FFE4B5;}");
  webpage += F(".style4 {text-align:center;font-size:20px;background-color:#FFE4B5;}");
  webpage += F(".style5 {text-align:center;font-size:18px;background-color:#D8BFD8;}");
  webpage += F(".style6 td {border:0px solid black;text-align:right;padding:0px;font-size:13px;background-color:#B0C4DE;color:#0066ff;}");
  webpage += F(".style7 {text-align:center;font-size:14px;background-color:#F7F2Fd;}");
  webpage += F(".style8 {text-align:center;font-size:12px;border:0px solid black;padding:2px;color:#990099;}");
  webpage += F(".style9 {text-align:center;font-size:14px;color:blue;}");
  webpage += F("img.imgdisplay {display:block;margin-left:auto;margin-right:auto;}");
  webpage += F("sup {vertical-align:super;font-size:smaller;}");
  webpage += F("</style></head><body><h1>Weather Server ");
  webpage += version+"</h1>";
  webpage += F("<h2>Weather Forecast for ");
  webpage += City;
  webpage += F(" ");
  webpage += observationtime;
  webpage += F("</h2>");
}

void append_page_footer(){ // Saves repeating many lines of code for HTML page footers
  webpage += F("<ul><li><a href='/homepage'>Home Page</a></li>");
  webpage += F("<li><a href='/'>System Setup</a></li></ul>");
  webpage += F("<div class='footer'>&copy; Weather Underground Data and Icons 2017 <img src = 'https://icons.wxug.com/logos/JPG/wundergroundLogo_4c_horz.jpg' alt = 'not found' width='75' height='15'/><br>");
  webpage += "&copy;"+String(char(byte(0x40>>1)))+String(char(byte(0x88>>1)))+String(char(byte(0x5c>>1)))+String(char(byte(0x98>>1)))+String(char(byte(0x5c>>1)));
  webpage += String(char((0x84>>1)))+String(char(byte(0xd2>>1)))+String(char(0xe4>>1))+String(char(0xc8>>1))+String(char(byte(0x40>>1)));
  webpage += String(char(byte(0x64/2)))+String(char(byte(0x60>>1)))+String(char(byte(0x62>>1)))+String(char(0x6e>>1))+"</div>";
  webpage += F("</body></html>");
}

void SystemSetup() {
  String previous_city     = City;
  String previous_country  = Country;
  String previous_icon_set = icon_set;
  String previous_units    = Units;
  webpage = ""; // don't delete this command, it ensures the server works reliably!
  append_page_header();
  String IPaddress = WiFi.localIP().toString()+":"+String(port_2)+"/";
  webpage += F("<h3>System Setup, if required enter values then Enter</h3>");
  webpage += "<form action=\"http://"+IPaddress+"\" method=\"POST\">";
  webpage += F("City<br><input type='text' name='wu_city' value='");
  webpage += City;
  webpage += F("'><br>");
  webpage += F("Country<br><input  type='text' name='wu_country' value='");
  webpage += Country;
  webpage += F("'><br>");
  webpage += F("<input type='checkbox' name='iconset' value='a'>Icon-set A ");
  webpage += F("<input type='checkbox' name='iconset' value='b'>Icon-set B ");
  webpage += F("<input type='checkbox' name='iconset' value='c'>Icon-set C ");
  webpage += F("<input type='checkbox' name='iconset' value='d'>Icon-set D ");
  webpage += F("<input type='checkbox' name='iconset' value='e'>Icon-set E ");
  webpage += F("<input type='checkbox' name='iconset' value='f'>Icon-set F ");
  webpage += F("<input type='checkbox' name='iconset' value='g'>Icon-set G ");
  webpage += F("<input type='checkbox' name='iconset' value='h'>Icon-set H ");
  webpage += F("<input type='checkbox' name='iconset' value='i'>Icon-set I ");
  webpage += F("<input type='checkbox' name='iconset' value='j'>Icon-set J ");
  webpage += F("<input type='checkbox' name='iconset' value='k'>Icon-set K <br><br>");
  webpage += F("<input type='checkbox' name='units'   value='M'>Metric Units ");
  webpage += F("<input type='checkbox' name='units'   value='X'>Mixed Units ");
  webpage += F("<input type='checkbox' name='units'   value='I'>Imperial Units<br><br>");
  webpage += F("<input type='submit' value='Enter'><br><br>");
  webpage += F("</form>");
  append_page_footer();
//  server.send(200, "text/html", webpage); // Send a response to the client to enter their inputs, if needed, Enter=defaults
/*
  if (server.args() > 0 ) { // Arguments were received
    for ( uint8_t i = 0; i < server.args(); i++ ) {
      String Argument_Name   = server.argName(i);
      String client_response = server.arg(i);
      if (Argument_Name == "wu_city")    City    = client_response;
      if (Argument_Name == "wu_country") Country = client_response;
      if (Argument_Name == "iconset") {
        if (client_response.length() > 1) icon_set = "k"; else icon_set = client_response; // Checking for more than one check-box selected too
      }
      if (Argument_Name == "units") {
        if (client_response.length() > 1) Units = "X"; else Units = client_response; // Checking for more than one check-box selected too
      }
    }
  }
  */
  if (previous_city != City || previous_country != Country || previous_icon_set != icon_set || previous_units != Units) { // reduces calls to WU
    obtain_forecast("conditions");
    obtain_forecast("forecast");
    obtain_forecast("astronomy");
  }
}

// <img src='https://icons.wxug.com/logos/JPG/wundergroundLogo_4c.jpg' width='35' height='20'/>";
// https://icons.wxug.com/logos/JPG/wundergroundLogo_4c.jpg



#endif
